'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.readPackageJSON = exports.writeInstalled = exports.readInstalled = undefined;

let readInstalled = exports.readInstalled = function () {
  var ref = _asyncToGenerator(function* () {
    try {
      const state = yield _disk2.default.state.read();
      const installed = state.installed || [];
      _fns.log.externals('readInstalled', installed.join(' '));
      return installed;
    } catch (e) {
      print("Couldn't read installed packages");
      // handleError(e)
    }
  });

  return function readInstalled() {
    return ref.apply(this, arguments);
  };
}();

let writeInstalled = exports.writeInstalled = function () {
  var ref = _asyncToGenerator(function* (_packages, _paths) {
    try {
      _fns.log.externals('writeInstalled', '_packages', _packages.join(','), '_paths', _paths);
      const packages = (0, _rmExternals2.default)((0, _normalize2.default)(_packages));
      const paths = _paths || _cache2.default.getExternals();

      installed = packages;

      // write state.installed
      yield _disk2.default.state.write(function (state, write) {
        state.installed = packages;
        write(state);
      });

      // write full paths
      const fullPaths = (0, _filterWithPath2.default)(packages, paths);
      _fns.log.externals('writeInstalled', 'fullPaths', fullPaths.join(','));
      yield _disk2.default.externalsPaths.write(function (_, write) {
        return write(fullPaths);
      });
    } catch (e) {
      (0, _fns.handleError)(e);
    }
  });

  return function writeInstalled(_x, _x2) {
    return ref.apply(this, arguments);
  };
}();

let readPackageJSON = exports.readPackageJSON = function () {
  var ref = _asyncToGenerator(function* () {
    try {
      return yield readJSON(p((0, _opts2.default)('motionDir'), 'package.json'));
    } catch (e) {
      (0, _fns.handleError)(e);
    }
  });

  return function readPackageJSON() {
    return ref.apply(this, arguments);
  };
}();

exports.readInstalledCache = readInstalledCache;

var _normalize = require('./normalize');

var _normalize2 = _interopRequireDefault(_normalize);

var _cache = require('../../cache');

var _cache2 = _interopRequireDefault(_cache);

var _disk = require('../../disk');

var _disk2 = _interopRequireDefault(_disk);

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

var _fns = require('../../lib/fns');

var _rmExternals = require('./rmExternals');

var _rmExternals2 = _interopRequireDefault(_rmExternals);

var _filterWithPath = require('./filterWithPath');

var _filterWithPath2 = _interopRequireDefault(_filterWithPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

let installed = [];

function readInstalledCache() {
  return installed;
}
//# sourceMappingURL=installed.js.map