'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.app = undefined;

let app = exports.app = function () {
  var ref = _asyncToGenerator(function* () {
    try {
      const dest = (0, _fns.p)((0, _opts2.default)('buildDir'), '_');
      const deps = (0, _opts2.default)('deps');
      const minify = (0, _opts2.default)('config').minify;

      let appFiles = yield (0, _fns.readdir)((0, _opts2.default)('outDir'));
      appFiles = appFiles.map(function (f) {
        return f.fullPath;
      }).filter(function (x) {
        return !(0, _helpers.isSourceMap)(x);
      }).sort();

      if (minify) print(`  Minifying...`.dim);

      // build parallel
      yield Promise.all([buildForDeploy(deps.internalsOut, { dest, minify }), buildForDeploy(deps.externalsOut, { dest, minify }), buildForDeploy(appFiles, { dest, minify, combine: true, wrap: true })]);
    } catch (e) {
      (0, _fns.handleError)(e);
    }
  });

  return function app() {
    return ref.apply(this, arguments);
  };
}();

var _motionTransform = require('motion-transform');

var _motionTransform2 = _interopRequireDefault(_motionTransform);

var _babel = require('./babel');

var _babel2 = _interopRequireDefault(_babel);

var _helpers = require('./lib/helpers');

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _fns = require('../lib/fns');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function buildForDeploy(src, _ref) {
  let dest = _ref.dest;
  let combine = _ref.combine;
  let minify = _ref.minify;
  let wrap = _ref.wrap;

  return new Promise((resolve, reject) => {
    _helpers.gulp.src(src).pipe(_helpers.$.sourcemaps.init())
    // .pipe($.if(combine, $.order(src)))
    .pipe(_helpers.$.if(combine, _helpers.$.concat(`${ (0, _opts2.default)('saneName') }.js`))).pipe(_helpers.$.if(wrap, _babel2.default.app())).pipe(_helpers.$.if(minify, _helpers.$.uglify())).pipe(_helpers.$.sourcemaps.write('.')).pipe(_helpers.gulp.dest(dest)).on('end', () => {
      _fns.log.gulp('finished', src);
      resolve();
    }).on('error', reject);
  });
}
//# sourceMappingURL=app.js.map