'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stream = require('stream');

var _vinyl = require('vinyl');

var _vinyl2 = _interopRequireDefault(_vinyl);

var _chokidar = require('chokidar');

var _chokidar2 = _interopRequireDefault(_chokidar);

var _fns = require('../../lib/fns');

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

// TODO copying a directory of files over is broken in gulp.watch / gulp-watch
// when a whole dir is copied in, find files and push into stream

let stream = new _stream.Readable({ objectMode: true });
stream._read = function (n) {};

function init(baseDir) {
  _chokidar2.default.watch(baseDir, {
    ignored: /[\/\\]\./,
    ignoreInitial: true
  }).on('addDir', (() => {
    var ref = _asyncToGenerator(function* (dir) {
      try {
        // TODO use globber from gulp
        const files = yield (0, _fns.readdir)(dir, {
          fileFilter: ['*.js'],
          directoryFilter: ['!.git', '!node_modules', '!.motion', '!.*']
        });

        // push
        files.forEach((() => {
          var ref = _asyncToGenerator(function* (_ref) {
            let fullPath = _ref.fullPath;

            const source = yield (0, _fns.readFile)(fullPath);
            const toStream = new _vinyl2.default((0, _fns.vinyl)(baseDir, fullPath, new Buffer(source)));
            stream.push(toStream);
          }),
              _this = this;

          return function (_x2) {
            return ref.apply(_this, arguments);
          };
        })());
      } catch (e) {
        (0, _fns.handleError)(e);
      }
    }),
        _this = this;

    return function (_x) {
      return ref.apply(_this, arguments);
    };
  })());

  return stream;
}

exports.default = init;
//# sourceMappingURL=dirAddStream.js.map