'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _autoprefixer = require('autoprefixer');

var _autoprefixer2 = _interopRequireDefault(_autoprefixer);

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _fns = require('./fns');

var _bridge = require('../bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

let styleDir;

exports.default = function () {
  var ref = _asyncToGenerator(function* (view, sheet) {
    try {
      styleDir = styleDir || _fns.path.join((0, _opts2.default)('appDir'), '.motion', '.internal', 'styles');
      const file = _fns.path.join(styleDir, `${ view }.css`);
      const prefixed = yield (0, _postcss2.default)([_autoprefixer2.default]).process(sheet);
      let final = prefixed.css;

      yield (0, _fns.writeFile)(file, final);
      if (!(0, _opts2.default)('hasRunInitialBuild')) return;
      _bridge2.default.broadcast('stylesheet:add', { view, file });
    } catch (e) {
      (0, _fns.handleError)(e);
    }
  });

  return function writeStyle(_x, _x2) {
    return ref.apply(this, arguments);
  };
}();
//# sourceMappingURL=writeStyle.js.map